"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var axios_1 = require("axios");
var errors_1 = require("../errors");
var handleError_1 = require("../util/handleError");
var SESSION_URL = function (host) { return host + "/rest/auth/1/session"; };
var WORKLOG_URL = function (host) {
    return host + "/rest/tempo-timesheets/3/worklogs/";
};
var DELETE_WORKLOG_URL = function (host, issueId, worklogId) { return "\n" + host + "/rest/api/2/issue/" + issueId + "/worklog/" + worklogId; };
var JiraClient = /** @class */ (function () {
    function JiraClient(host, credentials) {
        this.host = host;
        this.credentials = credentials;
        this.cookie = "";
    }
    JiraClient.prototype.obtainCookie = function () {
        return __awaiter(this, void 0, void 0, function () {
            var axiosInstance, retVal, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        axiosInstance = axios_1["default"].create({
                            validateStatus: function (status) { return status === 200; },
                            timeout: 10000
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axiosInstance.post(SESSION_URL(this.host), this.credentials)];
                    case 2:
                        retVal = _a.sent();
                        this.cookie = "JSESSIONID=" + retVal.data.session.value;
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        throw errors_1.AuthenticationError.fromAxiosError(e_1);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    JiraClient.prototype.createWorklog = function (item) {
        return __awaiter(this, void 0, void 0, function () {
            var res, e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, axios_1["default"].post(WORKLOG_URL(this.host), item, this.getRequestOptions())];
                    case 1:
                        res = _a.sent();
                        return [2 /*return*/, {
                                id: res.data.id,
                                issueId: res.data.issue.key,
                                date: res.data.dateStarted
                            }];
                    case 2:
                        e_2 = _a.sent();
                        handleError_1.handleError(e_2, e_2.response.status === 400
                            ? "No Ticket for '" + item.issue.key + "' found"
                            : undefined, "warning");
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/, null];
                }
            });
        });
    };
    JiraClient.prototype.deleteWorklog = function (log) {
        return __awaiter(this, void 0, void 0, function () {
            var e_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, axios_1["default"]["delete"](DELETE_WORKLOG_URL(this.host, log.issueId, log.id), this.getRequestOptions())];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        e_3 = _a.sent();
                        handleError_1.handleError(e_3, "Could not delete worklog " + log.id + " for issue " + log.issueId, "warning");
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    JiraClient.prototype.getRequestOptions = function () {
        return {
            headers: {
                "Content-Type": "application/json",
                Cookie: this.cookie
            }
        };
    };
    return JiraClient;
}());
exports.JiraClient = JiraClient;
