"use strict";
exports.__esModule = true;
var fs = require("fs-extra");
var path = require("path");
var const_1 = require("../const");
var HOST_FILE = path.join("jira", "host.json");
var CREDENTIALS_FILE = path.join("jira", "credentials.json");
var WORKLOGS_FILE = path.join("jira", "worklogs.json");
var JiraStore = /** @class */ (function () {
    function JiraStore() {
    }
    JiraStore.prototype.getHost = function () {
        try {
            return fs.readFileSync(const_1.CREATE_PATH(HOST_FILE), "UTF-8");
        }
        catch (e) {
            return null;
        }
    };
    JiraStore.prototype.setHost = function (host) {
        fs.outputFileSync(const_1.CREATE_PATH(HOST_FILE), host);
    };
    JiraStore.prototype.getCredentials = function () {
        return fs.readJsonSync(const_1.CREATE_PATH(CREDENTIALS_FILE), {
            encoding: "UTF-8",
            throws: false
        });
    };
    JiraStore.prototype.setCredentials = function (credentials) {
        fs.outputJsonSync(const_1.CREATE_PATH(CREDENTIALS_FILE), credentials);
    };
    JiraStore.prototype.getExistingEntries = function () {
        var _a;
        return (_a = fs
            .readJsonSync(const_1.CREATE_PATH(WORKLOGS_FILE), {
            encoding: "UTF-8",
            throws: false
        })) === null || _a === void 0 ? void 0 : _a.map(function (entry) { return ({
            id: entry.id,
            issueId: entry.issueId,
            date: new Date(entry.date)
        }); });
    };
    JiraStore.prototype.setExistingEntries = function (entries) {
        fs.outputJsonSync(const_1.CREATE_PATH(WORKLOGS_FILE), entries);
    };
    return JiraStore;
}());
exports.JiraStore = JiraStore;
